• Русский
  • Workspace [kubeflow.org/v1beta1]

    Description
    Workspace is the Schema for the Workspaces API
    Type
    object

    Specification

    PropertyTypeDescription
    apiVersionstring

    APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

    kindstring

    Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

    metadataObjectMeta

    ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

    specobject

    WorkspaceSpec defines the desired state of Workspace

    statusobject

    WorkspaceStatus defines the observed state of Workspace

    .spec

    Description
    WorkspaceSpec defines the desired state of Workspace
    Type
    object
    Required
    kindpodTemplate
    PropertyTypeDescription
    deferUpdatesboolean

    if true, pending updates are NOT applied when the Workspace is paused if false, pending updates are applied when the Workspace is paused

    kindstring

    the WorkspaceKind to use

    pausedboolean

    if the workspace is paused (no pods running)

    podTemplateobject

    options for "podTemplate"-type WorkspaceKinds

    .spec.podTemplate

    Description
    options for "podTemplate"-type WorkspaceKinds
    Type
    object
    Required
    optionsvolumes
    PropertyTypeDescription
    optionsobject

    the selected podTemplate options

    podMetadataobject

    metadata to be applied to the Pod resource

    volumesobject

    volume configs

    .spec.podTemplate.options

    Description
    the selected podTemplate options
    Type
    object
    Required
    imageConfigpodConfig
    PropertyTypeDescription
    imageConfigstring

    the id of an imageConfig option

    • options are defined in WorkspaceKind under spec.podTemplate.options.imageConfig.values[]
    podConfigstring

    the id of a podConfig option

    • options are defined in WorkspaceKind under spec.podTemplate.options.podConfig.values[]

    .spec.podTemplate.podMetadata

    Description
    metadata to be applied to the Pod resource
    Type
    object
    PropertyTypeDescription
    annotationsobject

    annotations to be applied to the Pod resource

    labelsobject

    labels to be applied to the Pod resource

    .spec.podTemplate.podMetadata.annotations

    Description
    annotations to be applied to the Pod resource
    Type
    object

    .spec.podTemplate.podMetadata.labels

    Description
    labels to be applied to the Pod resource
    Type
    object

    .spec.podTemplate.volumes

    Description
    volume configs
    Type
    object
    PropertyTypeDescription
    dataarray

    additional PVCs to mount

    • these PVC must already exist in the Namespace
    • the same PVC can be mounted multiple times with different mountPaths
    • if readOnly is false, the PVC must be RWX (ReadWriteMany, ReadWriteOnce)
    • if readOnly is true, the PVC must be ReadOnlyMany
    homestring

    the name of the PVC to mount as the home volume

    • this PVC must already exist in the Namespace
    • this PVC must be RWX (ReadWriteMany, ReadWriteOnce)
    • the mount path is defined in the WorkspaceKind under spec.podTemplate.volumeMounts.home

    .spec.podTemplate.volumes.data

    Description
    additional PVCs to mount - these PVC must already exist in the Namespace - the same PVC can be mounted multiple times with different `mountPaths` - if `readOnly` is false, the PVC must be RWX (ReadWriteMany, ReadWriteOnce) - if `readOnly` is true, the PVC must be ReadOnlyMany
    Type
    array

    .spec.podTemplate.volumes.data[]

    Type
    object
    Required
    mountPathpvcName
    PropertyTypeDescription
    mountPathstring

    the mount path for the PVC

    pvcNamestring

    the name of the PVC to mount

    readOnlyboolean

    if the PVC should be mounted as ReadOnly

    .status

    Description
    WorkspaceStatus defines the observed state of Workspace
    Type
    object
    Required
    activitypauseTimependingRestartpodTemplateOptionspodTemplatePodstatestateMessage
    PropertyTypeDescription
    activityobject

    activity information for the Workspace, used to determine when to cull

    pauseTimeinteger

    the time when the Workspace was paused (UNIX epoch)

    • set to 0 when the Workspace is NOT paused
    pendingRestartboolean

    if the current Pod does not reflect the current "desired" state

    • true if any spec.podTemplate.options have a redirect and so will be patched on the next restart
    • true if the WorkspaceKind has changed one of its common podTemplate fields like podMetadata, probes, extraEnv, or containerSecurityContext
    podTemplateOptionsobject

    information about the current podTemplate options (only set for WorkspaceKind of podTemplate kind)

    podTemplatePodobject

    information about the Pod managed by this Workspace (only set for WorkspaceKind of podTemplate kind)

    statestring

    the current state of the Workspace

    stateMessagestring

    a human-readable message about the state of the Workspace

    • WARNING: this field is NOT FOR MACHINE USE, subject to change without notice

    .status.activity

    Description
    activity information for the Workspace, used to determine when to cull
    Type
    object
    Required
    lastActivitylastUpdate
    PropertyTypeDescription
    lastActivityinteger

    the last time activity was observed on the Workspace (UNIX epoch)

    lastUpdateinteger

    the last time we checked for activity on the Workspace (UNIX epoch)

    .status.podTemplateOptions

    Description
    information about the current podTemplate options (only set for WorkspaceKind of podTemplate kind)
    Type
    object
    Required
    imageConfigpodConfig
    PropertyTypeDescription
    imageConfigobject

    info about the current imageConfig option

    podConfigobject

    info about the current podConfig option

    .status.podTemplateOptions.imageConfig

    Description
    info about the current imageConfig option
    Type
    object
    PropertyTypeDescription
    desiredstring

    the option id which will take effect after the next restart

    redirectChainarray

    the chain from the current option to the desired option

    .status.podTemplateOptions.imageConfig.redirectChain

    Description
    the chain from the current option to the desired option
    Type
    array

    .status.podTemplateOptions.imageConfig.redirectChain[]

    Type
    object
    Required
    sourcetarget
    PropertyTypeDescription
    sourcestring

    the source option id

    targetstring

    the target option id

    .status.podTemplateOptions.podConfig

    Description
    info about the current podConfig option
    Type
    object
    PropertyTypeDescription
    desiredstring

    the option id which will take effect after the next restart

    redirectChainarray

    the chain from the current option to the desired option

    .status.podTemplateOptions.podConfig.redirectChain

    Description
    the chain from the current option to the desired option
    Type
    array

    .status.podTemplateOptions.podConfig.redirectChain[]

    Type
    object
    Required
    sourcetarget
    PropertyTypeDescription
    sourcestring

    the source option id

    targetstring

    the target option id

    .status.podTemplatePod

    Description
    information about the Pod managed by this Workspace (only set for WorkspaceKind of podTemplate kind)
    Type
    object
    Required
    name
    PropertyTypeDescription
    containersarray

    information about the Pod's containers

    initContainersarray

    information about the Pod's initContainers

    namestring

    the name of the Pod resource

    .status.podTemplatePod.containers

    Description
    information about the Pod's containers
    Type
    array

    .status.podTemplatePod.containers[]

    Type
    object
    Required
    name
    PropertyTypeDescription
    namestring

    the name of the container

    .status.podTemplatePod.initContainers

    Description
    information about the Pod's initContainers
    Type
    array

    .status.podTemplatePod.initContainers[]

    Type
    object
    Required
    name
    PropertyTypeDescription
    namestring

    the name of the container

    API Endpoints

    The following API endpoints are available:

    • /apis/kubeflow.org/v1beta1/namespaces/{namespace}/workspaces
      • DELETE: delete collection of Workspace
      • GET: list objects of kind Workspace
      • POST: create a new Workspace
    • /apis/kubeflow.org/v1beta1/namespaces/{namespace}/workspaces/{name}
      • DELETE: delete the specified Workspace
      • GET: read the specified Workspace
      • PATCH: partially update the specified Workspace
      • PUT: replace the specified Workspace
    • /apis/kubeflow.org/v1beta1/namespaces/{namespace}/workspaces/{name}/status
      • GET: read status of the specified Workspace
      • PATCH: partially update status of the specified Workspace
      • PUT: replace status of the specified Workspace

    /apis/kubeflow.org/v1beta1/namespaces/{namespace}/workspaces

    HTTP method
    DELETE
    Description
    delete collection of Workspace
    HTTP responses
    HTTP codeResponse body
    200 - OKStatus schema
    401 - UnauthorizedEmpty
    HTTP method
    GET
    Description
    list objects of kind Workspace
    HTTP responses
    HTTP codeResponse body
    200 - OKWorkspaceList schema
    401 - UnauthorizedEmpty
    HTTP method
    POST
    Description
    create a new Workspace
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyWorkspace schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKWorkspace schema
    201 - CreatedWorkspace schema
    202 - AcceptedWorkspace schema
    401 - UnauthorizedEmpty

    /apis/kubeflow.org/v1beta1/namespaces/{namespace}/workspaces/{name}

    HTTP method
    DELETE
    Description
    delete the specified Workspace
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    HTTP responses
    HTTP codeResponse body
    200 - OKStatus schema
    202 - AcceptedStatus schema
    401 - UnauthorizedEmpty
    HTTP method
    GET
    Description
    read the specified Workspace
    HTTP responses
    HTTP codeResponse body
    200 - OKWorkspace schema
    401 - UnauthorizedEmpty
    HTTP method
    PATCH
    Description
    partially update the specified Workspace
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    HTTP responses
    HTTP codeResponse body
    200 - OKWorkspace schema
    401 - UnauthorizedEmpty
    HTTP method
    PUT
    Description
    replace the specified Workspace
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyWorkspace schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKWorkspace schema
    201 - CreatedWorkspace schema
    401 - UnauthorizedEmpty

    /apis/kubeflow.org/v1beta1/namespaces/{namespace}/workspaces/{name}/status

    HTTP method
    GET
    Description
    read status of the specified Workspace
    HTTP responses
    HTTP codeResponse body
    200 - OKWorkspace schema
    401 - UnauthorizedEmpty
    HTTP method
    PATCH
    Description
    partially update status of the specified Workspace
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    HTTP responses
    HTTP codeResponse body
    200 - OKWorkspace schema
    401 - UnauthorizedEmpty
    HTTP method
    PUT
    Description
    replace status of the specified Workspace
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyWorkspace schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKWorkspace schema
    201 - CreatedWorkspace schema
    401 - UnauthorizedEmpty